## deepin-control-center-5.4.70-2.src.tar.gz

=== src/frame/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(VERSION 4.0)

set(BIN_NAME dde-control-center)

# set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall -Wl,--as-need -fPIE")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi")
endif()

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")

# disable qt keywords, cause gio have signals member;
ADD_DEFINITIONS(-DQT_NO_KEYWORDS)

if (DEFINED ENABLE_MIEEE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

set(DEFINED_LIST
DISABLE_OPACITY_ANIMATION
DISABLE_CLOUD_SYNC
DISABLE_SYS_UPDATE
DISABLE_ACCOUNT
DISABLE_DISPLAY
DISABLE_DEFAULT_APPLICATIONS
DISABLE_PERSONALIZATION
DISABLE_NETWORK
DISABLE_BLUETOOTH
DISABLE_SOUND
DISABLE_DATETIME
DISABLE_POWER
DISABLE_MOUSE
DISABLE_KAYBOARD
DISABLE_WACOM
DISABLE_SYSINFO
DISABLE_NETWORK_PPPOE
DISABLE_NETWORK_VPN
DISABLE_NETWORK_PROXY
DISABLE_SYS_UPDATE_SOURCE_CHECK
DISABLE_SYS_UPDATE_MIRRORS
DISABLE_MAIN_PAGE
DISABLE_RECOVERY
DCC_ENABLE_ADDOMAIN
DCC_DISABLE_KBLAYOUT
DCC_DISABLE_LANGUAGE
DCC_DISABLE_POWERSAVE
DCC_DISABLE_FEEDBACK
DCC_DISABLE_ROTATE
DCC_DISABLE_MIRACAST
DCC_DISABLE_TIMEZONE
DCC_DISABLE_GRUB
DCC_KEEP_SETTINGS_LIVE
DCC_COMMUNITY_LICENSE
)

foreach(LETTER ${DEFINED_LIST})
    if(DEFINED ${LETTER})
        add_definitions(-D${LETTER})
    endif()
endforeach()

# load files
set(FRAME_FILES
                main.cpp
                dbuscontrolcenterservice.cpp
)

set(WINDOW_FILES
    window/mainwindow.cpp
    window/utils.h
    window/gsettingwatcher.cpp
    window/gsettingwatcher.h
    window/accessibleinterface.h
    window/accessible.h
    window/protocolfile.cpp
    window/insertplugin.cpp
    window/insertplugin.h
    window/modules/display/displaywidget.cpp
    window/modules/datetime/datetimemodule.cpp
    window/modules/datetime/datetimewidget.cpp
    window/modules/datetime/datewidget.cpp
    window/modules/datetime/clockitem.cpp
    window/modules/datetime/clock.cpp
    window/modules/datetime/timezonelist.cpp
    window/modules/datetime/timezonecontentlist.cpp
    window/modules/datetime/systemtimezone.cpp
    window/modules/datetime/formatsetting.cpp
    window/modules/datetime/formatsetting.h
    window/modules/datetime/datesettings.cpp
    window/modules/datetime/timesetedit.cpp
    window/modules/datetime/datetimecombox.cpp
    window/modules/datetime/timespinbox.cpp
    window/modules/display/displaymodule.cpp
    window/modules/display/scalingwidget.cpp
    window/modules/display/resolutionwidget.cpp
    window/modules/display/brightnesswidget.cpp
    window/modules/display/rotatewidget.cpp
    window/modules/display/refreshratewidget.cpp
    window/modules/display/multiscreenwidget.cpp
    window/modules/display/secondaryscreendialog.cpp
    window/modules/touchscreen/touchscreenmodule.cpp
    window/modules/touchscreen/touchscreenwidget.cpp
    window/modules/power/powermodule.cpp
    window/modules/power/powerwidget.cpp
    window/modules/power/generalwidget.cpp
    window/modules/power/useelectricwidget.cpp
    window/modules/power/usebatterywidget.cpp
    window/modules/sound/soundwidget.cpp
    window/modules/sound/soundmodule.cpp
    window/modules/sound/speakerpage.cpp
    window/modules/sound/microphonepage.cpp
    window/modules/sound/soundeffectspage.cpp
    window/modules/sound/devicemanagespage.cpp
    window/modules/update/updatemodule.cpp
    window/modules/update/updatewidget.cpp
    window/modules/update/updatectrlwidget.cpp
    window/modules/update/updatesettings.cpp
    window/modules/update/loadingitem.cpp
    window/modules/update/updatehistorybutton.cpp
    window/modules/update/recenthistoryapplist.cpp
    window/modules/update/mirrorswidget.cpp
    window/modules/update/mirrorsourceitem.cpp
    window/search/searchwidget.cpp
    window/modules/commoninfo/commoninfomodule.cpp
    window/modules/commoninfo/commoninfowidget.cpp
    window/modules/commoninfo/commoninfomodel.cpp
    window/modules/commoninfo/commoninfowork.cpp
    window/modules/commoninfo/bootwidget.cpp
    window/modules/commoninfo/commonbackgrounditem.cpp
    window/modules/commoninfo/userexperienceprogramwidget.cpp
    window/modules/wacom/wacommodule.cpp
    window/modules/wacom/wacomwidget.cpp
    window/modules/wacom/wacomworker.cpp
    window/modules/wacom/wacommodel.cpp
    window/modules/wacom/pressuresettings.cpp
    window/modules/commoninfo/developermodewidget.cpp
    window/modules/commoninfo/developermodedialog.cpp
)

# load interfaces
set(INTERFACES_FILES
                interfaces/frameproxyinterface.h
                interfaces/moduleinterface.h
                interfaces/plugininterface.h

                ../../include/interface/moduleinterface.h
                ../../include/interface/frameproxyinterface.h
)

# load widgets
set(WIDGETS_FILES
                widgets/backbutton.cpp
                widgets/basiclistdelegate.cpp
                ../../include/widgets/basiclistdelegate.h
                widgets/buttontuple.cpp
                widgets/dccslider.cpp
                ../../include/widgets/dccslider.h
                widgets/dccsliderannotated.cpp
                ../../include/widgets/dccsliderannotated.h
                ../../include/widgets/labels/largelabel.h
                ../../include/widgets/labels/normallabel.h
                ../../include/widgets/labels/smalllabel.h
                ../../include/widgets/labels/tipslabel.h
                widgets/lineeditwidget.cpp
                widgets/loadingindicator.cpp
                ../../include/widgets/loadingindicator.h
                widgets/loadingnextpagewidget.cpp
                widgets/nextbutton.cpp
                widgets/optionlistpage.cpp
                widgets/searchinput.cpp
                ../../include/widgets/searchinput.h
                widgets/separator.cpp
                ../../include/widgets/separator.h
                widgets/settingsheaderitem.cpp
                ../../include/widgets/settingsheaderitem.h
                widgets/settingsitem.cpp
                ../../include/widgets/settingsitem.h
                widgets/spinboxwidget.cpp
                ../../include/widgets/spinboxwidget.h
                widgets/buttoneditwidget.cpp
                ../../include/widgets/buttoneditwidget.h
                widgets/tipsitem.cpp
                ../../include/widgets/tipsitem.h
                widgets/titlelabel.cpp
                ../../include/widgets/titlelabel.h
                widgets/titlevalueitem.cpp
                ../../include/widgets/titlevalueitem.h
                widgets/translucentframe.cpp
                ../../include/widgets/translucentframe.h
                widgets/settingsgroup.cpp
                widgets/switchwidget.cpp
                widgets/comboxwidget.cpp
                ../../include/widgets/comboxwidget.h
                widgets/themeitempic.cpp
                ../../include/widgets/themeitempic.h
                ../../include/widgets/utils.h
                ../../include/widgets/backbutton.h
                widgets/basiclistmodel.cpp
                ../../include/widgets/basiclistmodel.h
                widgets/basiclistview.cpp
                ../../include/widgets/basiclistview.h
                ../../include/widgets/buttontuple.h
                widgets/comboboxwidget.cpp
                ../../include/widgets/comboboxwidget.h
                widgets/contentwidget.cpp
                ../../include/widgets/contentwidget.h
                widgets/editablenextpagewidget.cpp
                ../../include/widgets/editablenextpagewidget.h
                widgets/filechoosewidget.cpp
                ../../include/widgets/filechoosewidget.h
                ../../include/widgets/lineeditwidget.h
                ../../include/widgets/loadingnextpagewidget.h
                ../../include/widgets/nextbutton.h
                widgets/nextpagewidget.cpp
                ../../include/widgets/nextpagewidget.h
                widgets/optionitem.cpp
                ../../include/widgets/optionitem.h
                ../../include/widgets/optionlistpage.h
                ../../include/widgets/settingsgroup.h
                widgets/settingshead.cpp
                ../../include/widgets/settingshead.h
                ../../include/widgets/switchwidget.h
                widgets/themeitem.cpp
                ../../include/widgets/themeitem.h
                widgets/titledslideritem.cpp
                ../../include/widgets/titledslideritem.h
                widgets/timeoutdialog.cpp
                ../../include/widgets/timeoutdialog.h
                widgets/multiselectlistview.cpp
                ../../include/widgets/multiselectlistview.h
                widgets/powerdisplaywidget.cpp
                ../../include/widgets/powerdisplaywidget.h
                widgets/passwordedit.cpp
                ../../include/widgets/passwordedit.h
                widgets/widgets.qrc
)

# load modules
set(MODULE_FILES
)

# load accounts
set(ACCOUNTS_FILES
                modules/accounts/creationresult.cpp
                modules/accounts/removeuserdialog.cpp
                modules/accounts/useroptionitem.cpp
                modules/accounts/widgets/fingeritem.cpp
                modules/accounts/widgets/fingerwidget.cpp
                modules/accounts/accountsworker.cpp
                modules/accounts/avatarwidget.cpp
                modules/accounts/fingermodel.cpp
                modules/accounts/fingerworker.cpp
                modules/accounts/user.cpp
                modules/accounts/usermodel.cpp
                window/modules/accounts/accountsmodule.cpp
                window/modules/accounts/accountswidget.cpp
                window/modules/accounts/pwqualitymanager.cpp
                window/modules/accounts/createaccountpage.cpp
                window/modules/accounts/modifypasswdpage.cpp
                window/modules/accounts/accountsdetailwidget.cpp
                window/modules/accounts/avatarlistwidget.cpp
                window/modules/accounts/avataritemdelegate.cpp
                window/modules/accounts/accountfingeitem.cpp
                window/modules/accounts/addfingedialog.cpp
                window/modules/accounts/fingerwidget.cpp
                window/modules/accounts/onlineicon.cpp
)

# load bluetooth
set(BLUETOOTH_FILES
                modules/bluetooth/pincodedialog.cpp
                modules/bluetooth/adapter.cpp
                modules/bluetooth/bluetoothmodel.cpp
                modules/bluetooth/bluetoothworker.cpp
                modules/bluetooth/device.cpp
                window/modules/bluetooth/titleedit.cpp
                window/modules/bluetooth/devicesettingsitem.cpp
                window/modules/bluetooth/detailpage.cpp
                window/modules/bluetooth/adapterwidget.cpp
                window/modules/bluetooth/bluetoothwidget.cpp
                window/modules/bluetooth/bluetoothmodule.cpp
)

#load datetime
set(DATETIME_FILES
                modules/datetime/clock.cpp
                modules/datetime/timezone_dialog/file_util.cpp
                modules/datetime/timezone_dialog/popup_menu_delegate.cpp
                modules/datetime/timezone_dialog/timezone.cpp
                modules/datetime/timezone_dialog/timezone_map_util.cpp
                modules/datetime/timezone_dialog/tooltip_pin.cpp
                modules/datetime/timezone_dialog/popup_menu.cpp
                modules/datetime/timezone_dialog/timezone_map.cpp
                modules/datetime/timezone_dialog/timezonechooser.cpp
                modules/datetime/timezoneitem.cpp
                modules/datetime/datetimemodel.cpp

=== tests/dccwidgets/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(BIN_NAME dccwidgets-unittest)

# 自动生成moc文件
set(CMAKE_AUTOMOC ON)

# 源文件
file(GLOB_RECURSE SRCS "*.cpp")

# 用于测试覆盖率的编译条件
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

# Address Sanitizer 内存错误检测工具,打开下面的编译选项可以看到调试信息，正常运行时不需要这些信息
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

# 查找依赖库
find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS Widgets Test DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(GTest REQUIRED)

pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

# 添加执行文件信息
add_executable(${BIN_NAME} ${SRCS} ${INTERFACES})

# 链接库
target_link_libraries(${BIN_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
    -lm
)

target_include_directories(${BIN_NAME} PUBLIC
    ${CMAKE_SOURCE_DIR}/include
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)

=== tests/dde-control-center/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(dde-control-center-unittest)

set(BLUETOOTH_NAME bluetooth-unittest)
set(MOUSE_NAME mouse-unittest)
set(DATETIME_NAME datetime-unittest)
set(NOTIFICATION_NAME notification-unittest)
set(DEFAPP_NAME defapp-unittest)
set(SYSTEMINFO_NAME systeminfo-unittest)
set(KEYBOARD_NAME keyboard-unittest)

# 自动生成moc文件
set(CMAKE_AUTOMOC ON)

# Address Sanitizer 内存错误检测工具,打开下面的编译选项可以看到调试信息，正常运行时不需要这些信息
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address -O2")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=address -O2")
endif()

# 蓝牙模块源文件
file(GLOB_RECURSE BLUETOOTH_SRCS "bluetooth/*.cpp" "bluetooth/*.h")

#蓝牙模块依赖文件
file(GLOB_RECURSE BLUETOOTH_Tasks_SRCS
  ../../src/frame/modules/bluetooth/*.cpp

  ../../src/frame/window/modules/bluetooth/bluetoothwidget.cpp
  ../../src/frame/window/modules/bluetooth/adapterwidget.cpp
  ../../src/frame/window/modules/bluetooth/titleedit.cpp
  ../../src/frame/window/modules/bluetooth/devicesettingsitem.cpp
  ../../src/frame/window/modules/bluetooth/detailpage.cpp

  ../../src/frame/window/gsettingwatcher.cpp
  fakedbus/bluetooth_dbus.cpp
)

# 时间日期模块源文件
file(GLOB_RECURSE DATETIME_SRCS "datetime/*.cpp" "datetime/*.h")

# 时间日期模块依赖文件
file(GLOB_RECURSE DATETIME_Tasks_SRCS
    ../../src/frame/modules/datetime/datetimework.cpp
    ../../src/frame/modules/datetime/datetimemodel.cpp
    ../../src/frame/modules/datetime/timezoneitem.cpp
    ../../src/frame/modules/datetime/clock.cpp

    fakedbus/datetime_dbus.cpp
)

# 鼠标模块源文件
file(GLOB_RECURSE MOUSE_SRCS "mouse/*.cpp" "mouse/*.h")

# 鼠标模块依赖文件
file(GLOB_RECURSE MOUSE_Tasks_SRCS
  ../../src/frame/modules/mouse/mouseworker.cpp
  ../../src/frame/modules/mouse/mousemodel.cpp
  ../../src/frame/modules/mouse/doutestwidget.cpp
  ../../src/frame/modules/mouse/palmdetectsetting.cpp

  ../../src/frame/window/modules/mouse/mousewidget.cpp
  ../../src/frame/window/modules/mouse/generalsettingwidget.cpp
  ../../src/frame/window/modules/mouse/mousesettingwidget.cpp
  ../../src/frame/window/modules/mouse/touchpadsettingwidget.cpp
  ../../src/frame/window/modules/mouse/trackpointsettingwidget.cpp

  ../../src/frame/window/utils.h
  ../../src/frame/window/insertplugin.cpp
  ../../src/frame/window/gsettingwatcher.cpp
)

#通知模块源文件
file(GLOB_RECURSE NOTIFICATION_SRCS "notification/*.cpp" "notification/*.h")

#通知模块依赖文件
file(GLOB_RECURSE NOTIFICATION_Tasks_SRCS
  ../../src/frame/modules/notification/*.cpp
  ../../src/frame/window/gsettingwatcher.cpp
  ../../src/frame/window/modules/notification/notificationwidget.cpp
  ../../src/frame/window/modules/notification/appnotifywidget.cpp
  ../../src/frame/window/modules/notification/notificationitem.cpp
  ../../src/frame/window/modules/notification/systemnotifywidget.cpp
  ../../src/frame/window/modules/notification/timeslotitem.cpp

  fakedbus/notification_dbus.cpp
)

# 默认程序源文件
file(GLOB_RECURSE DEFAPP_SRCS "defapp/*.cpp" "defapp/*.h")

# 默认程序依赖文件
file(GLOB_RECURSE DEFAPP_Tasks_SRCS
  ../../src/frame/modules/defapp/defappworker.cpp
  ../../src/frame/modules/defapp/defappmodel.cpp
  ../../src/frame/modules/defapp/model/category.cpp
  ../../src/frame/window/gsettingwatcher.cpp
  ../../src/frame/window/insertplugin.cpp
  ../../src/frame/widgets/multiselectlistview.cpp

  ../../src/frame/window/modules/defapp/defappdetailwidget.cpp
  ../../src/frame/window/modules/defapp/defappwidget.cpp

  fakedbus/defapp_dbus.cpp
)

# 系统信息模块源文件
file(GLOB_RECURSE SYSTEMINFO_SRCS "systeminfo/*.cpp" "systeminfo/*.h")

# 系统信息依赖文件
file(GLOB_RECURSE SYSTEMINFO_Tasks_SRCS

   #../../src/frame/window/modules/systeminfo/*.cpp
   ../../src/frame/window/modules/systeminfo/privacypolicywidget.cpp
   ../../src/frame/window/modules/systeminfo/systeminfowidget.cpp
   ../../src/frame/window/modules/systeminfo/nativeinfowidget.cpp
   ../../src/frame/window/modules/systeminfo/userlicensewidget.cpp
   ../../src/frame/window/modules/systeminfo/versionprotocolwidget.cpp
   ../../src/frame/modules/systeminfo/*.cpp
   ../../src/frame/window/gsettingwatcher.cpp
   ../../src/frame/window/insertplugin.cpp
   ../../src/frame/window/utils.h
   ../../src/frame/window/protocolfile.cpp
)

# 键盘测试模块源文件
file(GLOB_RECURSE KEYBOARD_SRCS "keyboard/*.cpp")

# 头文件路径
set(KEYBOARD_HEADER 
    ../../src/frame/window/modules/keyboard
    ../../src/frame/modules/keyboard
)

# 键盘测试依赖文件
file(GLOB_RECURSE KEYBOARD_Tasks_SRCS 
    ../../src/frame/window/modules/keyboard/generalkbsettingwidget.cpp
    ../../src/frame/window/modules/keyboard/kblayoutsettingwidget.cpp
    ../../src/frame/window/modules/keyboard/systemlanguagewidget.cpp
    ../../src/frame/window/modules/keyboard/systemlanguagesettingwidget.cpp
    ../../src/frame/window/modules/keyboard/shortcutsettingwidget.cpp
    ../../src/frame/modules/keyboard/keyboardmodel.cpp
    ../../src/frame/modules/keyboard/indexmodel.cpp
    ../../src/frame/modules/keyboard/shortcutmodel.cpp
    ../../src/frame/modules/keyboard/shortcutitem.cpp
    ../../src/frame/modules/keyboard/shortcutkey.cpp
    ../../src/frame/window/gsettingwatcher.cpp
    ../../src/frame/modules/display/displaymodel.cpp
    ../../src/frame/modules/display/monitor.cpp
    ../../src/frame/modules/keyboard/keylabel.cpp
    ../../src/frame/window/utils.h
)

# 用于测试覆盖率的编译条件
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")

# 查找依赖库
find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS Widgets Test DBus REQUIRED Concurrent Svg)
find_package(DtkWidget REQUIRED)
find_package(GTest REQUIRED)

pkg_check_modules(QGSettings REQUIRED gsettings-qt)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)

# 添加蓝牙模块执行文件信息
add_executable(${BLUETOOTH_NAME} ${BLUETOOTH_SRCS} ${BLUETOOTH_Tasks_SRCS})

# 添加时间日期模块执行文件信息
add_executable(${DATETIME_NAME} ${DATETIME_SRCS} ${DATETIME_Tasks_SRCS})

# 添加鼠标模块执行文件信息
add_executable(${MOUSE_NAME} ${MOUSE_SRCS} ${MOUSE_Tasks_SRCS})

# 添加通知模块执行文件信息
add_executable(${NOTIFICATION_NAME} ${NOTIFICATION_SRCS} ${NOTIFICATION_Tasks_SRCS})

# 添加默认程序模块执行文件信息
add_executable(${DEFAPP_NAME} ${DEFAPP_SRCS} ${DEFAPP_Tasks_SRCS})

# 添加系统信息模块执行文件信息
add_executable(${SYSTEMINFO_NAME} ${SYSTEMINFO_SRCS} ${SYSTEMINFO_Tasks_SRCS})

# 添加键盘模块执行文件信息
add_executable(${KEYBOARD_NAME} ${KEYBOARD_SRCS} ${KEYBOARD_Tasks_SRCS})

# 蓝牙模块链接库
target_link_libraries(${BLUETOOTH_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 蓝牙模块引用头文件
target_include_directories(${BLUETOOTH_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 时间日期模块链接库
target_link_libraries(${DATETIME_NAME} PUBLIC
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 时间日期模块引用头文件
target_include_directories(${DATETIME_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 鼠标模块链接库
target_link_libraries(${MOUSE_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 鼠标模块引用头文件
target_include_directories(${MOUSE_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 通知模块链接库
target_link_libraries(${NOTIFICATION_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 通知模块引用头文件
target_include_directories(${NOTIFICATION_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 默认程序模块链接库
target_link_libraries(${DEFAPP_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 默认程序模块引用头文件
target_include_directories(${DEFAPP_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 系统信息模块链接库
target_link_libraries(${SYSTEMINFO_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 键盘模块链接库
target_link_libraries(${KEYBOARD_NAME} PRIVATE
    dccwidgets
    ${Qt5Test_LIBRARIES}
    ${Qt5DBus_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${QGSettings_LIBRARIES}
    ${Qt5Concurrent_LIBRARIES}
    ${Qt5Svg_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    ${GTEST_LIBRARIES}
    -lpthread
)

# 系统信息模块引用头文件
target_include_directories(${SYSTEMINFO_NAME} PUBLIC
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Concurrent_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

# 键盘模块引用头文件
target_include_directories(${KEYBOARD_NAME} PUBLIC
    ${KEYBOARD_HEADER}
    ${DtkWidget_INCLUDE_DIRS}
    ${QGSettings_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${DFrameworkDBus_INCLUDE_DIRS}
)

add_custom_target(check
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tests/dde-control-center)

#'make check'命令依赖与我们的测试程序
add_dependencies(check ${BLUETOOTH_NAME} ${MOUSE_NAME} ${DATETIME_NAME} ${NOTIFICATION_NAME} ${DEFAPP_NAME} ${SYSTEMINFO_NAME} ${KEYBOARD_NAME})

include_directories(../../src/frame)
include_directories(fakedbus)

=== debian/changelog ===
dde-control-center (3.0.14-1) unstable; urgency=low

  * Autobuild Tag 3.0.14 

 -- TagBuilder <tagbuilder@deepin.com>  Fri, 12 Aug 2016 18:43:22 +0000

dde-control-center (3.0.13-1) unstable; urgency=low

  * Autobuild Tag 3.0.13 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Thu, 26 May 2016 17:24:07 +0000

dde-control-center (3.0.12-1) unstable; urgency=low

  * Autobuild Tag 3.0.12 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Mon, 23 May 2016 14:49:33 +0000

dde-control-center (3.0.10-7) unstable; urgency=low

  * Rebuild Version 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Mon, 25 Apr 2016 11:20:16 +0000

dde-control-center (3.0.10-6) unstable; urgency=low

  * Rebuild Version 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Thu, 21 Apr 2016 16:16:22 +0000

dde-control-center (3.0.10-5) unstable; urgency=low

  * Rebuild Version 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 09 Mar 2016 15:25:09 +0000

dde-control-center (3.0.10-4) unstable; urgency=low

  * Rebuild Version 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 09 Mar 2016 12:33:35 +0000

dde-control-center (3.0.10-3) unstable; urgency=low

  * Rebuild Version 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 09 Mar 2016 11:38:29 +0000

dde-control-center (3.0.10-2) unstable; urgency=low

  * Rebuild Version 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 09 Mar 2016 11:07:31 +0000

dde-control-center (3.0.10-1) unstable; urgency=low

  * Autobuild Tag 3.0.10 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Mon, 07 Mar 2016 17:01:12 +0000

dde-control-center (3.0.9-3) stable; urgency=low

  * Rebuild Version 3.0.9 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Thu, 25 Feb 2016 16:16:18 +0000

dde-control-center (3.0.9-2) stable; urgency=low

  * Rebuild Version 3.0.9 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Thu, 25 Feb 2016 11:24:31 +0000

dde-control-center (3.0.9-1) stable; urgency=low

  * Autobuild Tag 3.0.9 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Thu, 25 Feb 2016 11:09:23 +0000

dde-control-center (3.0.8-1) stable; urgency=low

  * Autobuild Tag 3.0.8 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Mon, 22 Feb 2016 17:01:22 +0000

dde-control-center (3.0.7-1) stable; urgency=low

  * Autobuild Tag 3.0.7 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 27 Jan 2016 18:51:35 +0000

dde-control-center (3.0.6-1) stable; urgency=low

  * Autobuild Tag 3.0.6 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Fri, 22 Jan 2016 20:10:14 +0000

dde-control-center (3.0.5-3) stable; urgency=low

  * Rebuild Version 3.0.5 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Fri, 15 Jan 2016 17:44:02 +0000

dde-control-center (3.0.5-2) stable; urgency=low

  * Rebuild Version 3.0.5 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Fri, 15 Jan 2016 16:02:54 +0000

dde-control-center (3.0.5-1) stable; urgency=low

  * Autobuild Tag 3.0.5 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Fri, 15 Jan 2016 15:44:01 +0000

dde-control-center (3.0.4-1) stable; urgency=low

  * Autobuild Tag 3.0.4 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Tue, 12 Jan 2016 20:08:17 +0000

dde-control-center (3.0.3-1) stable; urgency=low

  * Autobuild Tag 3.0.3 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 06 Jan 2016 16:42:35 +0000

dde-control-center (3.0.2-1) stable; urgency=low

  * Autobuild Tag 3.0.2 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Wed, 30 Dec 2015 15:16:56 +0000

dde-control-center (3.0.1-1) stable; urgency=low

  * Autobuild Tag 3.0.1 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Tue, 29 Dec 2015 21:43:24 +0000

dde-control-center (3.0.0-1) stable; urgency=low

  * Autobuild Tag 3.0.0 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Mon, 28 Dec 2015 21:15:54 +0000

dde-control-center (2.91.6-2) stable; urgency=low

  * Rebuild Version 2.91.6 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Tue, 22 Dec 2015 13:22:00 +0000

dde-control-center (2.91.6-1) stable; urgency=low

  * Autobuild Tag 2.91.6 

 -- TagBuilder <tagbuilder@linuxdeepin.com>  Mon, 21 Dec 2015 22:37:34 +0000

dde-control-center (2.91.5-2) stable; urgency=low

  * Rebuild Version 2.91.5 

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Sun, 20 Dec 2015 12:43:15 +0000

dde-control-center (2.91.5-1) stable; urgency=low

  * Autobuild Tag 2.91.5 

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Sat, 19 Dec 2015 15:58:24 +0000

dde-control-center (2.91.4-1) stable; urgency=low

  * Autobuild Tag 2.91.4 

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Thu, 10 Dec 2015 20:33:06 +0000

dde-control-center (2.91.3-1) stable; urgency=low

  * Autobuild Tag 2.91.3 

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Wed, 09 Dec 2015 22:25:45 +0000

dde-control-center (2.91.2-1) stable; urgency=low

  * Autobuild Tag 2.91.2 

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Fri, 20 Nov 2015 17:02:56 +0000

dde-control-center (2.91.1-1) stable; urgency=low

  * Autobuild Tag 2.91.1 

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Fri, 20 Nov 2015 09:52:29 +0000

dde-control-center (2.90.1+r1494~g999cab5) experimental; urgency=low

  ** Build revision: 999cab57c67c88f9a9065963c61c0cd262897918  @  origin/release/2.3 **

  [upstreamer]
  * Use DPalette to replace DConstants
  * Hide remoting module for 2015 test
  * Show error message when failed to connect to remote peer
  * Fixed: show error page on peerIdFailed
  * Merge branch 'develop' into release/2.3

 -- TagBuilder <tabbuilder@linuxdeepin.com>  Thu, 02 Jul 2015 13:55:11 +0000

dde-control-center (0.0.0) unstable; urgency=medium

  * Unstable release.

 -- 宋文武 <songwenwu@linuxdeepin.com>  Tue, 02 Dec 2014 10:19:15 +0800

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Josip Ponjavic <josipponjavic at gmail dot com>
# Contributor: Xu Fasheng <fasheng.xu[AT]gmail.com>

pkgname=deepin-control-center
pkgver=5.4.70
pkgrel=2
pkgdesc='New control center for linux deepin'
arch=('x86_64')
url="https://github.com/linuxdeepin/dde-control-center"
license=('GPL3')
depends=('desktop-file-utils' 'dtkwidget' 'deepin-account-faces' 'deepin-api' 'geoip' 'libpwquality'
         'geoip-database' 'geoip-database-extra' 'deepin-daemon' 'startdde' 'networkmanager-qt'
         'deepin-qt-dbus-factory' 'deepin-qt5integration' 'deepin-network-utils' 'deepin-pw-check')
makedepends=('cmake' 'deepin-dock' 'gmock' 'gtest' 'ninja' 'qt5-tools')
optdepends=('redshift: automatic color temperature support'
            'networkmanager-openconnect: for OpenConnect support'
            'networkmanager-openvpn: for OpenVPN support'
            'networkmanager-pptp: for PPTP support'
            'networkmanager-strongswan: for StrongSwan support'
            'networkmanager-vpnc: for VPNC support'
            'network-manager-sstp: for SSTP support')
# Not packaged: network-manager-l2tp
conflicts=('dde-control-center' 'dde-dock-applets')
replaces=('dde-control-center' 'dde-dock-applets')
groups=('deepin')
source=("https://github.com/linuxdeepin/dde-control-center/archive/$pkgver/$pkgname-$pkgver.tar.gz"
        $pkgname-systeminfo-deepin-icon.patch
        $pkgname-no-user-experience.patch
        $pkgname-hide-end-user-license.patch::https://github.com/linuxdeepin/dde-control-center/pull/387.patch)
sha512sums=('95e10dbc450ef20224d36634e27535f3175a6ea3b802ad8089e2352d3a0ef9b3e337cc5a6981afeb1e4a60ace1e3b9c838ada1a2fe7f39e6f12a23fa34e62271'
            '74fd63391e923ca37f4559f30da967ba7f33d4426b60d58d1ece8cd9a154578e8184b1a376a8d7ff3ef81ffce530915f79d0845a2612ae4e06522b96855ab3dd'
            'b7f766e4dad9840a716ac22458b387626da712f56a546475f71639182273417bd3135b978a3926fe234bf7bae0c353c1d7cbb08ad386c2691f6b1223b1938bfa'
            'c3f2366d1ac361d3577548329910fe218ae076078084a72543d67b1804ebe437479bf0f592166d3b00d120fe9cf16e4e89fb6ddb82430d9e0e4d0a90266b51ee')

prepare() {
  rm dde-control-center-$pkgver/src/frame/window/icons/icons/dcc_nav_systeminfo_{42,84}px.svg
  patch -d dde-control-center-$pkgver -Np1 < $pkgname-systeminfo-deepin-icon.patch
  patch -d dde-control-center-$pkgver -Np1 < $pkgname-no-user-experience.patch
  patch -d dde-control-center-$pkgver -Np1 < $pkgname-hide-end-user-license.patch
  mkdir -p build

  cd dde-control-center-$pkgver
  # remove after they obey -DDISABLE_SYS_UPDATE properly
  sed -i '/new UpdateModule/d' src/frame/window/mainwindow.cpp

  sed -i '/#include <QPointer>/i #include <QDBusMetaType>' src/frame/window/modules/network/connectioneditpage.h
}

build() {
  cd build
  cmake -GNinja -DDISABLE_SYS_UPDATE=YES -DDISABLE_RECOVERY=YES -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_LIBDIR=/usr/lib \
    ../dde-control-center-$pkgver
  ninja
}

check() {
  cd build
  ninja test
}

package() {
  cd build
  DESTDIR="$pkgdir" ninja install
}

=== debian/control ===
Source: dde-control-center
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 11),
 pkg-config,
 ninja-build,
 libx11-dev,
 cmake,
 qtbase5-dev,
 qtdeclarative5-dev,
 libqt5svg5-dev,
 libdtkcore-dev,
 libdtkwidget-dev,
 libdtkgui-dev,
 libdframeworkdbus-dev,
 libgsettings-qt-dev,
 qttools5-dev-tools,
 clang [amd64],
 libdde-network-utils-dev,
 libdtkcore5-bin,
 libkf5networkmanagerqt-dev,
 qtbase5-private-dev,
 libxrandr-dev,
 libmtdev-dev,
 libfontconfig1-dev,
 libfreetype6-dev,
 libegl1-mesa-dev,
 libxcb-ewmh-dev,
 libudisks2-qt5-dev,
 qtmultimedia5-dev,
 deepin-desktop-base | deepin-desktop-server | deepin-desktop-device,
 libgtest-dev,
 libdeepin-pw-check-dev,
 libpolkit-qt5-1-dev
Standards-Version: 3.9.5
Homepage: https://github.com/linuxdeepin/dde-control-center

Package: dde-control-center
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${dist:Depends},
 dde-account-faces,
 dde-daemon (>=5.12.0.31),
 startdde (>=5.6.0.34),
 lastore-daemon (>=5.1.0.21),
 dde-api (>=2.92.1),
 xkb-data,
 deepin-installer-timezones,
 passwd,
 netselect,
 uos-license-content,
 libglib2.0-0,
 libdeepin-pw-check,
 deepin-desktop-schemas (>=5.8.0.34),
 libdframeworkdbus2 (>=5.3.38),
 libdde-network-utils(>=5.4.9)
Recommends: 
 netselect, 
 deepin-ab-recovery,
 deepin-user-experience-daemon,
 deepin-recovery-plugin
Suggests: redshift
Conflicts:
 dde-control-center-plugin-weather,
 dde-control-center-plugin-notify
Replaces:
 dde-control-center-plugin-weather,
 dde-control-center-plugin-notify
Description: New control center for Deepin Desktop Environment,
 Integrated control center with rich functions,Besides providing rich 
 system setting items, the function level is simple, the logic is clear, 
 the user can easily set the system, and the learning cost is low,
 Provide users with automatic update system and developer mode to meet 
 the various needs of users for the operating system.
 abrecovery -restore system, Determine whether the system is restored
 reboot-reminder-dialog -Update restart, Confirm whether to restart the system 
 after the completion of the update.
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-dev
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}, ${shlib:Depends}, ${dist:Depends}
Description: New control center for Deepin Desktop Environment - development files
 DDE Control Center is the control panel of Deepin Desktop Environment.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk

export QT_SELECT = qt5
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
export DEB_BUILD_OPTIONS=nocheck parallel=-1
SYSTYPE=Desktop
SYSTYPE=$(shell cat /etc/deepin-version | grep Type= | awk -F'=' '{print $$2}')

%:
ifeq ($(DEB_BUILD_ARCH), mips64el)
	dh $@ --parallel --buildsystem=cmake+ninja
else ifeq ($(DEB_BUILD_ARCH), sw_64)
	dh $@ --parallel --buildsystem=cmake+ninja
else
	dh $@ --parallel
endif

ifeq ($(DEB_BUILD_ARCH), amd64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), x86_64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), mips64el)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), mipsel)
override_dh_auto_configure:
	dh_auto_configure -- \
		-DDCC_ENABLE_AUTOSTART=YES \
		-DDCC_DISABLE_OPACITY_ANIMATION=YES \
		-DDCC_KEEP_SETTINGS_LIVE=YES \
		-DDCC_DISABLE_MIRACAST=YES \
		-DDCC_DISABLE_GRUB=YES \
		-DDISABLE_SYS_UPDATE_MIRRORS=YES \
		-DDCC_DISABLE_LANGUAGE=YES -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), arm64)
override_dh_auto_configure:
	dh_auto_configure -- -DDISABLE_SYS_UPDATE_SOURCE_CHECK=YES \
		-DDISABLE_SYS_UPDATE_MIRRORS=YES -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), sw_64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif

ifeq ($(DEB_BUILD_ARCH), loongarch64)
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM)
endif
